# -*- coding: utf-8 -*-

import json
from functools import reduce
import random
import pprint
# import sys
# print("Python version")
# print (sys.version)
# print("Version info.")
# print (sys.version_info)

# exit(0)

json_string = '''{
    "name": "Vida inteligente",
    "children": [
    {
        "name": "Atractivo de ciudad",
        "children": [
        {
            "name": "Atractivo laboral/residencial",
            "children": [
            {
                "name": "Autocontención laboral" ,
                "size": 0.36
            },
            {
                "name": "Saldo migratorio",
                "size": 0.24
            }
            ]
        },
        {
            "name": "Atractivo turístico",
            "children": [
            {
                "name": "Visitantes en la ciudad",
                "size": 0.16
            },
            {
                "name": "Visitantes que repiten",
                "size": 0.24
            }
            ]
        }
        ]
    },
    {
        "name": "Salud",
        "children": [
        {
            "name": "Accesibilidad a recursos sanitarios",
            "children": [
            {
                "name": "Proximidad ciudadana a un centro de atención primaria",
                "size": 0.2
            }
            ]
        },
        {
            "name": "Recursos sanitarios",
            "children": [
            {
                "name": "Capacidad sanitaria municipal de atención primaria",
                "size": 0.3
            }
            ]
        },
        {
            "name": "Vida saludable",
            "children": [
            {
                "name": "Esperanza de vida al nacer",
                "size": 0.5
            }
            ]
        }
        ]
    }
    ]
}'''
try:
    json_config = json.loads(json_string)
except Exception as ex:
    raise ex

def dict_walker(walk_guide, dict_to_modify, nesting=[], actions={}):
    """
    Navigate recursively the dictionary executin action in dict_to_modify 
    when a key is found.
    :param walk_guide: A shallow copy of dict_to_modify to avoid invalidate iterators
    :type walk_guide: dict
    :param dict_to_modify: The dictionary to modify basing on some rule walking it's copy
    :type dict_to_modify: dict
    :param nesting: Take trace of the nesting key during recursion. nesting is always passed by copy
    :type nesting: list
    :param actions: A set of match key value/callback e.g. {'keyvalue':callback,...} where 
                    callback as the following API callback(keyvalue, target)
    :type actions: list of tuples
    """
    if isinstance(walk_guide, dict):
        for key, value in walk_guide.items():
            new_nesting = list(nesting)
            new_nesting.append(key)
            dict_walker(value, dict_to_modify, nesting=new_nesting, actions=actions)
    elif isinstance(walk_guide, list):
        for index, value in enumerate(walk_guide):
            new_nesting = list(nesting)
            new_nesting.append(index)
            dict_walker(value, dict_to_modify, nesting=new_nesting, actions=actions)
    else:
        # manage a leaf, e.g. walk_guide now contains the leaf value
        value = walk_guide
        key = nesting[-1]
        # print(key, actions.keys())
        if key in actions.keys():
            callback = actions[key]
            print("trasfromaaaaaaaaaaaaaa", key)
            target = reduce( lambda k, v: k[v], nesting[:-1], dict_to_modify)
            print(nesting, "---------", value, target)
            callback(key, target)
            # target['newkey'] = random.random()

def firstcall(key, target):
    print('>>>>>>>>>>>>>>>>>> ', key, target[key])
    target['newnewkey'] = key
def secondcall(key, target):
    target['uuuuuuu'] = random.random()



class walker():

    walked_dictionary = {}
    actions = {}
    trigger_keys = []
    guide = {}
    nesting = []

    def __init__(self, walked_dictionary, actions):
        self.guide = dict(walked_dictionary)
        self.walked_dictionary = walked_dictionary
        self.actions = actions
        self.trigger_keys = self.actions.keys()
    
    def introspect(self, value=None):
        if not value:
            value = self.walked_dictionary
        if isinstance(value, dict):
            for key, val in value.items():
                self.nesting.append(key)
                self.introspect(val)
                del self.nesting[-1]
        elif isinstance(value, list):
            for index, val in enumerate(value):
                self.nesting.append(index)
                self.introspect(val)
                del self.nesting[-1]
        else:
            # manage a leaf, e.g. self.guide now contains the leaf value
            key = self.nesting[-1]
            if key in self.trigger_keys:
                callback = self.actions[key]
                print("trasfromaaaaaaaaaaaaaa", key)
                target = reduce( lambda k, v: k[v], self.nesting[:-1], self.walked_dictionary)
                print(self.nesting, "---------", value, target)
                callback(key, target)


if __name__ == '__main__':
    guide = dict(json_config)
    actions={'size':firstcall, 'name':secondcall}
    actions={'size':firstcall}
    # dict_walker(guide, json_config, nesting=[],actions=actions)


    print(json_config['children'][0]['name'])
    exit(0) 


    w = walker(json_config, actions)
    w.introspect()

    pp = pprint.PrettyPrinter(indent=2)
    pp.pprint(json_config)

    new_json = json.dumps(json_config)
    pp.pprint(new_json)





